
import java.io.*;
import java.net.*;
import java.util.*;

class ServerSocketThread extends SocketThread {

	ServerSocketThread(SocketCaller caller){
		this.caller = caller;
		start();
	};
	
	SocketCaller caller;
	Vector handlers = new Vector();

	
	public void run(){
		try 
      	{  
      		ServerSocket s = new ServerSocket(8189);
			
			while(true){
				Socket socket = s.accept();
				ThreadEchoHandler handler = new ThreadEchoHandler(socket);
				handler.start();
				handlers.addElement(handler);
			}
     	 }
     	 catch (Exception e){
     	 	System.out.println(e);
      	} 
      	
	}

	
	class ThreadEchoHandler extends Thread{
		Socket socket;
		PrintStream  out;
	
		ThreadEchoHandler(Socket _socket){
			socket = _socket;
		}
		public void run(){
			try{
				
			BufferedReader in
				= new BufferedReader(new InputStreamReader(socket.getInputStream()));
 
			out = new PrintStream(socket.getOutputStream());

			System.out.println("Socket Connected");

			caller.socketConnected();
			
    		boolean done = false;
         	while (!done)
         	{	  
         		String str = in.readLine();
            	if (str == null) done = true;
            	else
            	{  
            		//System.out.println("messageArrived "+str);
            		caller.messageArrived(str);
					
					broadcast(str, this);
            	}
       
         	}
         
         	socket.close();
				
			}
			catch(Exception e) {
				System.out.println(""+e);
			}
			handlers.removeElement(this);
		}
	}
	
	
	
	
	public void send(String str){
		for(int i=0; i<handlers.size(); i++){
			ThreadEchoHandler handler = (ThreadEchoHandler) handlers.elementAt(i);
			handler.out.println(str);
	    	handler.out.flush();
	    }
	}
	
	public void broadcast(String str, ThreadEchoHandler original_handler){
		for(int i=0; i<handlers.size(); i++){
			ThreadEchoHandler handler = (ThreadEchoHandler) handlers.elementAt(i);
			if (handler != original_handler){
				handler.out.println(str);
	    		handler.out.flush();
			}
	    }
	}

}